/*    
 * packet-test-idl.c
 * Routines for IDL dissection
 *
 * Autogenerated from ethereal_be.py
 * Copyright 2001 Frank Singleton <frank.singleton@ericsson.com>
 */


/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */


#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#ifdef HAVE_NETINET_IN_H
# include <netinet/in.h>
#endif

#ifdef NEED_SNPRINTF_H
# ifdef HAVE_STDARG_H
#  include <stdarg.h>
# else
#  include <varargs.h>
# endif
# include "snprintf.h"
#endif

#include <string.h>
#include <glib.h>
#include "packet.h"
#include "proto.h"
#include "packet-giop.h"



/* Initialise the protocol and subtree pointers */

static int proto_test = -1;

static gint ett_test = -1;



/* Initialise the initial Alignment */

static guint32  boundary = GIOP_HEADER_SIZE;  /* initial value */




/* Initialise the Registered fields */

/* TODO - Use registered fields */


/*
 * IDL Operations Start
 */
 
 
static const char Penguin_Echo_echoShort_op[] = "echoShort" ;
static const char Penguin_Echo_echoUShort_op[] = "echoUShort" ;
static const char Penguin_Echo_echoLong_op[] = "echoLong" ;
static const char Penguin_Echo_echoULong_op[] = "echoULong" ;
static const char Penguin_Echo_echoFloat_op[] = "echoFloat" ;
static const char Penguin_Echo_echoDouble_op[] = "echoDouble" ;
static const char Penguin_Echo_echoBoolean_op[] = "echoBoolean" ;
static const char Penguin_Echo_echoChar_op[] = "echoChar" ;
static const char Penguin_Echo_echoOctet_op[] = "echoOctet" ;
static const char Penguin_Echo_echoString_op[] = "echoString" ;
static const char Penguin_Echo_echoEnum_op[] = "echoEnum" ;
static const char Penguin_Echo_echo_ex1_op[] = "echo_ex1" ;
static const char Penguin_Echo_echo_ex2_op[] = "echo_ex2" ;
static const char Penguin_Echo_echo_ex3_op[] = "echo_ex3" ;
static const char Penguin_Echo_echoWString_op[] = "echoWString" ;
static const char Penguin_Echo_echoWChar_op[] = "echoWChar" ;
static const char Penguin_Echo_echoAny_op[] = "echoAny" ;

/*
 * IDL Operations End
 */
 

/*  Begin Exception Helper Functions  */


    
/*  End Exception Helper Functions  */



/*
 * IDL:Penguin/Echo/echoShort:1.0
 */
 

static void decode_Penguin_Echo_echoShort(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    gint16   s_octet2;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        s_octet2 = get_CDR_short(tvb,offset,stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-2,2,"basic_short = %i",s_octet2);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            s_octet2 = get_CDR_short(tvb,offset,stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-2,2,"Operation return value = %i",s_octet2);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoUShort:1.0
 */
 

static void decode_Penguin_Echo_echoUShort(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint16   u_octet2;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        u_octet2 = get_CDR_ushort(tvb,offset,stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-2,2,"basic_UShort = %u",u_octet2);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet2 = get_CDR_ushort(tvb,offset,stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-2,2,"Operation return value = %u",u_octet2);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoLong:1.0
 */
 

static void decode_Penguin_Echo_echoLong(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    gint32   s_octet4;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        s_octet4 = get_CDR_long(tvb,offset,stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-4,4,"basic_long = %i",s_octet4);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            s_octet4 = get_CDR_long(tvb,offset,stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-4,4,"Operation return value = %i",s_octet4);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoULong:1.0
 */
 

static void decode_Penguin_Echo_echoULong(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint32   u_octet4;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        u_octet4 = get_CDR_ulong(tvb,offset,stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-4,4,"basic_ULong = %u",u_octet4);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet4 = get_CDR_ulong(tvb,offset,stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-4,4,"Operation return value = %u",u_octet4);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoFloat:1.0
 */
 

static void decode_Penguin_Echo_echoFloat(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    gfloat   my_float;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        my_float = get_CDR_float(tvb,offset,stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-4,4,"basic_Float = %.6e",my_float);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            my_float = get_CDR_float(tvb,offset,stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-4,4,"Operation return value = %.6e",my_float);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoDouble:1.0
 */
 

static void decode_Penguin_Echo_echoDouble(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    gdouble   my_double;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        my_double = get_CDR_double(tvb,offset,stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-8,8,"basic_Double = %.15e",my_double);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            my_double = get_CDR_double(tvb,offset,stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-8,8,"Operation return value = %.15e",my_double);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoBoolean:1.0
 */
 

static void decode_Penguin_Echo_echoBoolean(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint8   u_octet1;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        u_octet1 = get_CDR_boolean(tvb,offset);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-1,1,"basic_boolean = %u",u_octet1);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet1 = get_CDR_boolean(tvb,offset);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-1,1,"Operation return value = %u",u_octet1);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoChar:1.0
 */
 

static void decode_Penguin_Echo_echoChar(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint8   u_octet1;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        u_octet1 = get_CDR_char(tvb,offset);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-1,1,"basic_Char = %u",u_octet1);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet1 = get_CDR_char(tvb,offset);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-1,1,"Operation return value = %u",u_octet1);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoOctet:1.0
 */
 

static void decode_Penguin_Echo_echoOctet(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint8   u_octet1;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        u_octet1 = get_CDR_octet(tvb,offset);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-1,1,"basic_Octet = %u",u_octet1);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet1 = get_CDR_octet(tvb,offset);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-1,1,"Operation return value = %u",u_octet1);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoString:1.0
 */
 

static void decode_Penguin_Echo_echoString(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint32   u_octet4;
    gchar   *seq;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        u_octet4 = get_CDR_string(tvb, &seq, offset, stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-4-u_octet4,4,"length = %u",u_octet4);
           if (u_octet4 > 0)
              proto_tree_add_text(tree,tvb,*offset-u_octet4,u_octet4,"mesg = %s",seq);
           
        }
        
        g_free(seq);          /*  free buffer  */
        seq = NULL;
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet4 = get_CDR_string(tvb, &seq, offset, stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-4-u_octet4,4,"length = %u",u_octet4);
               if (u_octet4 > 0)
                  proto_tree_add_text(tree,tvb,*offset-u_octet4,u_octet4,"Operation return value = %s",seq);
               
            }
            
            g_free(seq);          /*  free buffer  */
            seq = NULL;
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoEnum:1.0
 */
 

static void decode_Penguin_Echo_echoEnum(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint32   u_octet4;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        
        /* TODO - translate Enum val into symbolic value */
            
        u_octet4 = get_CDR_enum(tvb,offset,stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-4,4,"Enum value = %u ",u_octet4);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            
            /* Function returns void */
            
            
            
            /* TODO - translate Enum val into symbolic value */
                
            u_octet4 = get_CDR_enum(tvb,offset,stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-4,4,"Enum value = %u ",u_octet4);
            }
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echo_ex1:1.0
 */
 

static void decode_Penguin_Echo_echo_ex1(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            
            /* Function returns void */
            
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echo_ex2:1.0
 */
 

static void decode_Penguin_Echo_echo_ex2(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            
            /* Function returns void */
            
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echo_ex3:1.0
 */
 

static void decode_Penguin_Echo_echo_ex3(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint32   u_octet4;
    gchar   *seq;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet4 = get_CDR_string(tvb, &seq, offset, stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-4-u_octet4,4,"length = %u",u_octet4);
               if (u_octet4 > 0)
                  proto_tree_add_text(tree,tvb,*offset-u_octet4,u_octet4,"Operation return value = %s",seq);
               
            }
            
            g_free(seq);          /*  free buffer  */
            seq = NULL;
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoWString:1.0
 */
 

static void decode_Penguin_Echo_echoWString(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint32   u_octet4;
    gchar   *seq;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        u_octet4 = get_CDR_wstring(tvb, &seq, offset, stream_is_big_endian, boundary, header);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-4-u_octet4,4,"length = %u",u_octet4);
           if (u_octet4 > 0)
              proto_tree_add_text(tree,tvb,*offset-u_octet4,u_octet4,"basic_wstring = %s",seq);
           
        }
        
        g_free(seq);          /*  free buffer  */
        seq = NULL;
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet4 = get_CDR_wstring(tvb, &seq, offset, stream_is_big_endian, boundary, header);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-4-u_octet4,4,"length = %u",u_octet4);
               if (u_octet4 > 0)
                  proto_tree_add_text(tree,tvb,*offset-u_octet4,u_octet4,"Operation return value = %s",seq);
               
            }
            
            g_free(seq);          /*  free buffer  */
            seq = NULL;
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoWChar:1.0
 */
 

static void decode_Penguin_Echo_echoWChar(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    gint8   s_octet1;
    gchar   *seq;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        s_octet1 = get_CDR_wchar(tvb, &seq, offset, header);
        if (tree) {
            if (s_octet1 > 0)
                proto_tree_add_text(tree,tvb,*offset-1-s_octet1,1,"length = %u",s_octet1);
        
            if (s_octet1 < 0)
                s_octet1 = -s_octet1;
        
            if (s_octet1 > 0)
                proto_tree_add_text(tree,tvb,*offset-s_octet1,s_octet1,"basic_wchar = %s",seq);
                   
        }
                
        g_free(seq);          /*  free buffer  */
        seq = NULL;
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            s_octet1 = get_CDR_wchar(tvb, &seq, offset, header);
            if (tree) {
                if (s_octet1 > 0)
                    proto_tree_add_text(tree,tvb,*offset-1-s_octet1,1,"length = %u",s_octet1);
            
                if (s_octet1 < 0)
                    s_octet1 = -s_octet1;
            
                if (s_octet1 > 0)
                    proto_tree_add_text(tree,tvb,*offset-s_octet1,s_octet1,"Operation return value = %s",seq);
                       
            }
                    
            g_free(seq);          /*  free buffer  */
            seq = NULL;
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}


/*
 * IDL:Penguin/Echo/echoAny:1.0
 */
 

static void decode_Penguin_Echo_echoAny(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint32   u_octet4;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        
        /* TODO - translate Enum val into symbolic value */
            
        u_octet4 = get_CDR_enum(tvb,offset,stream_is_big_endian, boundary);
        if (tree) {
           proto_tree_add_text(tree,tvb,*offset-4,4,"Enum value = %u ",u_octet4);
        }
        
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            get_CDR_any(tvb,tree,offset,stream_is_big_endian, boundary, header);
            
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}

gboolean dissect_test(tvbuff_t *tvb, packet_info *pinfo, proto_tree *ptree, int *offset, MessageHeader *header, gchar *operation, gchar *idlname) {

    proto_item *ti = NULL;
    proto_tree *tree = NULL;            /* init later, inside if(tree) */
    
    gboolean be;                        /* big endianess */
    guint32  offset_saved = (*offset);  /* save in case we must back out */

    pinfo->current_proto = "TEST";

    if (check_col(pinfo->fd, COL_PROTOCOL))
       col_add_str(pinfo->fd, COL_PROTOCOL, "TEST");

    if (ptree) {
       ti = proto_tree_add_item(ptree, proto_test, tvb, *offset, tvb_length(tvb) - *offset, FALSE);
       tree = proto_item_add_subtree(ti, ett_test);
    }  


    be = is_big_endian(header);         /* get endianess - TODO use passed in stream_is_big_endian instead ? */

    

    switch(header->message_type) {
    
    case Request:
    case Reply:
    
    
        if (!strcmp(operation, Penguin_Echo_echoShort_op )) {
           decode_Penguin_Echo_echoShort(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoUShort_op )) {
           decode_Penguin_Echo_echoUShort(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoLong_op )) {
           decode_Penguin_Echo_echoLong(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoULong_op )) {
           decode_Penguin_Echo_echoULong(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoFloat_op )) {
           decode_Penguin_Echo_echoFloat(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoDouble_op )) {
           decode_Penguin_Echo_echoDouble(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoBoolean_op )) {
           decode_Penguin_Echo_echoBoolean(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoChar_op )) {
           decode_Penguin_Echo_echoChar(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoOctet_op )) {
           decode_Penguin_Echo_echoOctet(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoString_op )) {
           decode_Penguin_Echo_echoString(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoEnum_op )) {
           decode_Penguin_Echo_echoEnum(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echo_ex1_op )) {
           decode_Penguin_Echo_echo_ex1(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echo_ex2_op )) {
           decode_Penguin_Echo_echo_ex2(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echo_ex3_op )) {
           decode_Penguin_Echo_echo_ex3(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoWString_op )) {
           decode_Penguin_Echo_echoWString(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoWChar_op )) {
           decode_Penguin_Echo_echoWChar(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        if (!strcmp(operation, Penguin_Echo_echoAny_op )) {
           decode_Penguin_Echo_echoAny(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        
        break;
        
    case CancelRequest:
    case LocateRequest:
    case LocateReply:
    case CloseConnection:
    case MessageError:
    case Fragment:
       return FALSE;      /* not handled yet */
    
    default:
       return FALSE;      /* not handled yet */
    
    }   /* switch */
    
    

    return FALSE;

}  /* End of main dissector  */




/* Register the protocol with Ethereal */

void proto_register_test(void) {

   /* setup list of header fields */

   static hf_register_info hf[] = {

      /* no fields yet */
      
   };

   /* setup protocol subtree array */

   static gint *ett[] = {
      &ett_test,
   };

   /* Register the protocol name and description */
   
   proto_test = proto_register_protocol("Test Dissector Using GIOP API" , "TEST", "test" );

   proto_register_field_array(proto_test, hf, array_length(hf));
   proto_register_subtree_array(ett,array_length(ett));
   
}




/* register me as handler for these interfaces */

void proto_register_handoff_test(void) {


    
    #if 0
    
    /* Register for Explicit Dissection */
    
    register_giop_user_module(dissect_test, "TEST", "Penguin/Echo" );     /* explicit dissector */
    
    #endif
    
    
    
    
    /* Register for Heuristic Dissection */
    
    register_giop_user(dissect_test, "TEST" );     /* heuristic dissector */ 
    
    

}

