/*    
 * packet-test-idl.c
 * Routines for IDL dissection
 *
 * Autogenerated from ethereal_be.py
 * Copyright 2001 Frank Singleton <frank.singleton@ericsson.com>
 */


/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */


#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#ifdef HAVE_NETINET_IN_H
# include <netinet/in.h>
#endif

#ifdef NEED_SNPRINTF_H
# ifdef HAVE_STDARG_H
#  include <stdarg.h>
# else
#  include <varargs.h>
# endif
# include "snprintf.h"
#endif

#include <string.h>
#include <glib.h>
#include "packet.h"
#include "proto.h"
#include "packet-giop.h"



/* Initialise the protocol and subtree pointers */

static int proto_test = -1;

static gint ett_test = -1;



/* Initialise the initial Alignment */

static guint32  boundary = GIOP_HEADER_SIZE;  /* initial value */




/* Initialise the Registered fields */

/* TODO - Use registered fields */


/*
 * IDL Operations Start
 */
 
 
static const char HelloApp_Hello_sayHello_op[] = "sayHello" ;

/*
 * IDL Operations End
 */
 

/*  Begin Exception Helper Functions  */


    
/*  End Exception Helper Functions  */



/*
 * IDL:HelloApp/Hello/sayHello:1.0
 */
 

static void decode_HelloApp_Hello_sayHello(tvbuff_t *tvb, packet_info *pinfo, proto_tree *tree, int *offset, MessageHeader *header, gchar *operation) {

    gboolean stream_is_big_endian;          /* big endianess */

    
    /* Operation specific Variable declarations Begin */
    
    guint32   u_octet4;
    gchar   *seq;
    
    /* Operation specific Variable declarations End */
    
    
    stream_is_big_endian = is_big_endian(header);
    
    switch(header->message_type) {
    
    case Request:
    
        break;
        
    case Reply:
    
        switch(header->rep_status) {
        
        case NO_EXCEPTION:
        
            u_octet4 = get_CDR_string(tvb, &seq, offset, stream_is_big_endian, boundary);
            if (tree) {
               proto_tree_add_text(tree,tvb,*offset-4-u_octet4,4,"length = %u",u_octet4);
               if (u_octet4 > 0)
                  proto_tree_add_text(tree,tvb,*offset-u_octet4,u_octet4,"Operation return value = %s",seq);
               
            }
            
            g_free(seq);          /*  free buffer  */
            seq = NULL;
            
            break;
            
        case USER_EXCEPTION:
        
            break;
            
        default:
        
            /* Unknown Exception */
        
            g_warning("Unknown Exception ");
        
            
        
            break;
        
        
        }   /* switch(header->message_type) */
        
        break;   
        
    default:
    
        /* Unknown GIOP Message */
    
        g_warning("Unknown GIOP Message");
        
    
        break;
    
        
    } /* switch(header->message_type) */ 
    
}

gboolean dissect_test(tvbuff_t *tvb, packet_info *pinfo, proto_tree *ptree, int *offset, MessageHeader *header, gchar *operation, gchar *idlname) {

    proto_item *ti = NULL;
    proto_tree *tree = NULL;            /* init later, inside if(tree) */
    
    gboolean be;                        /* big endianess */
    guint32  offset_saved = (*offset);  /* save in case we must back out */

    pinfo->current_proto = "TEST";

    if (check_col(pinfo->fd, COL_PROTOCOL))
       col_add_str(pinfo->fd, COL_PROTOCOL, "TEST");

    if (ptree) {
       ti = proto_tree_add_item(ptree, proto_test, tvb, *offset, tvb_length(tvb) - *offset, FALSE);
       tree = proto_item_add_subtree(ti, ett_test);
    }  


    be = is_big_endian(header);         /* get endianess - TODO use passed in stream_is_big_endian instead ? */

    

    switch(header->message_type) {
    
    case Request:
    case Reply:
    
    
        if (!strcmp(operation, HelloApp_Hello_sayHello_op )) {
           decode_HelloApp_Hello_sayHello(tvb, pinfo, tree, offset, header, operation);
           return TRUE;
        }
        
        
        break;
        
    case CancelRequest:
    case LocateRequest:
    case LocateReply:
    case CloseConnection:
    case MessageError:
    case Fragment:
       return FALSE;      /* not handled yet */
    
    default:
       return FALSE;      /* not handled yet */
    
    }   /* switch */
    
    

    return FALSE;

}  /* End of main dissector  */




/* Register the protocol with Ethereal */

void proto_register_test(void) {

   /* setup list of header fields */

   static hf_register_info hf[] = {

      /* no fields yet */
      
   };

   /* setup protocol subtree array */

   static gint *ett[] = {
      &ett_test,
   };

   /* Register the protocol name and description */
   
   proto_test = proto_register_protocol("Test Dissector Using GIOP API" , "TEST", "test" );

   proto_register_field_array(proto_test, hf, array_length(hf));
   proto_register_subtree_array(ett,array_length(ett));
   
}




/* register me as handler for these interfaces */

void proto_register_handoff_test(void) {


    
    #if 0
    
    /* Register for Explicit Dissection */
    
    register_giop_user_module(dissect_test, "TEST", "HelloApp/Hello" );     /* explicit dissector */
    
    #endif
    
    
    
    
    /* Register for Heuristic Dissection */
    
    register_giop_user(dissect_test, "TEST" );     /* heuristic dissector */ 
    
    

}

